### Function

# GLib filename_from_uri

#### Declaration

    gchar*
    g_filename_from_uri (
      const gchar* uri,
      gchar** hostname,
      GError** error
    )

#### Description

Converts an escaped ASCII-encoded URI to a local filename in the encoding used for filenames.

Since GLib 2.78, the query string and fragment can be present in the URI, but are not part of the resulting filename. We take inspiration from https://url.spec.whatwg.org/#file-state, but we don’t support the entire standard.

#### Parameters

`uri`

  Type: `const gchar*`

  A uri describing a filename (escaped, encoded in ASCII).

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`hostname`

  Type: `gchar**`

  Location to store hostname for the URI. If there is no hostname in the URI, `NULL` will be stored in this location.

  The argument will be set by the function.
  The argument can be set to `NULL` by the function.
  The argument can be `NULL`.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.
  The value is a NUL terminated UTF-8 string.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gchar*`

A newly-allocated string holding the resulting filename, or `NULL` on an error.

The caller of the function takes ownership of the data, and is responsible for freeing it.
The value is a platform-native string, using the preferred OS encoding on Unix and UTF-8 on Windows.